/* Anti Web HTTPD */
/* HardCore Software */
/*
This software us Copyright (C) 2001 By HardCore Software.
The software is distributed under the terms of the GNU General Public
License. See the file 'LICENSE' for more details.
*/

/*  Configuration variables   */
  char cnfdir[MAXROOTDIRSIZE];
  int cnfport;

/*  Server Variables          */
  char *getreqs[MAXUSERS];
  char *ipaddrs[MAXUSERS];
  int infd[MAXUSERS];
  FILE *filefd[MAXUSERS];
  int sending[MAXUSERS]; /* 0=NOTHING  1=SENDING A FILE  2=RUNNING A CGI */
  int charsread[MAXUSERS];
  int filelen[MAXUSERS];
  int numofusers=0;
  struct timeval timeon[MAXUSERS];




void discon(int i) {
  close(infd[i]);
  if ((filefd[i] != (FILE *) -1) && filefd[i]!=NULL) fclose(filefd[i]);
  if (sending[i]>0) numofusers--;
  sending[i]=0;
  getreqs[i][0]=0;
  ipaddrs[i][0]=0;
  charsread[i]=-1;
  filelen[i]=0;
  infd[i]=-1;
  filefd[i]=(FILE *) -1; 
}


void die() {

int i;

  close(bindfd);

  for(i=0;i<=MAXUSERS-1;i++) {
    if (infd[i]!=-1) close(infd[i]);
    if ((filefd[i] != (FILE *) -1) && filefd[i]!=NULL) fclose(filefd[i]);
    free(getreqs[i]);
    free(ipaddrs[i]);
  }

  logthis(3,"Anti-Web shutting down!");
  exit(1);

}


/* What a tiny little function... */
void nada () {  }




void verifyconnsperip(int i) {

  int g,curr=0;

  if (MAXCONNSPERIP>0) {

    for(g=0;g<=MAXUSERS-1;g++) {
      if (ipaddrs[g][0]!=0)
        if (strcmp(ipaddrs[i],ipaddrs[g])==0) curr++;
    }

    if (curr>MAXCONNSPERIP) {
      send403(infd[i],1);
      logthis(3,"Dropped a connection: To many conns per IP");
      discon(i);
    }

  }

}



void verifytimeconnected() {

struct timeval tptime;

int g;

  if (USERTIMEOUT>0) {

    gettimeofday(&tptime,NULL);

    for (g=0;g<=MAXUSERS-1;g++)
      if (infd[g]!=-1)
        if (tptime.tv_sec > timeon[g].tv_sec+USERTIMEOUT) {
          logthis(3,"Dropped a connection: User unresponsive for to long");
          discon(g);
        }

  }

}







void parsecnfdir() {

char tpbuf[MAXROOTDIRSIZE+100];
int i;

/* Make sure the root dir doesn't end in a "/" */
if (cnfdir[strlen(cnfdir)-1]==SLASH) cnfdir[strlen(cnfdir)-1]=0;


snprintf(tpbuf,100,"%s/%s",cnfdir,STARTFILE);


i=doesfileexist(tpbuf);
if (i==0) {
  fprintf(stderr, "Unable to find %s\n",tpbuf);
  logthis(1,"Unable to find startfile. Typically index.html");
  exit(0); 
}

}



int isadir(char *tpbuf) {

  DIR *i;

  i=opendir(tpbuf); 
  if(i) { closedir(i); return 1; }
  return 0;

}



void status() {

int i;
char junkbuf[50];

snprintf(junkbuf, sizeof(junkbuf),"%d%d%d",pid,cnfport, (int) getuid());

fprintf(stdout," [*************************************************]\n");
fprintf(stdout," [       Anti-Web V%-6s by HardCore Software     ]\n",VERSION);
fprintf(stdout," [         **TAKE BACK SOME SIMPLICITY**           ]\n");
fprintf(stdout," [*************************************************]\n");
fprintf(stdout," [  DIRECTORY {%s}",cnfdir);
if(strlen(cnfdir)<35) 
  for(i=1;i<=35-strlen(cnfdir);i++) fprintf(stdout," "); fprintf(stdout,"]\n");
fprintf(stdout," [  -=PID {%d}=-=PORT {%d}=-=UID {%d}=-",pid,cnfport,(int) getuid());
for(i=1;i<=18-strlen(junkbuf);i++) fprintf(stdout," "); fprintf(stdout,"]\n");
fprintf(stdout," [*************************************************]\n");

#ifdef PERMCHECK
permcheck(cnfdir);
#endif

}


void usage() {
char tpbuf[MAXDATASIZE];

snprintf(tpbuf, sizeof(tpbuf),"Anti Web HTTPD By HardCore Software: V%s\n",VERSION);
fprintf(stderr,tpbuf);
fprintf(stderr,"usage: awhttpd <directory> [port]\n"); 

logthis(1,"Bad arguments");

exit(0); 

}


int isacgifile(char *thefile) {

  FILE *i; char tpbuf[20];

  memset(&tpbuf,0,20);

  i=fopen(thefile,"rb");

  if (i==NULL) return 0;

  fgets(tpbuf,19,i);
  
  fclose(i);

  if (strncasecmp(tpbuf,"--AWHTTPD SCRIPT--",19)==0) return 1;
  return 0;

}


int doesfileexist(char *tpbuf) {

  FILE *i;

  i=fopen(tpbuf,"rb");
  if (i==NULL) return 0;
  fclose(i);
  return 1;

}

int isfilesymlink(char *fname) {

  struct stat stbuf;

  lstat(fname, &stbuf);

  return ((stbuf.st_mode & S_IFMT) == S_IFLNK); 

}

long flength(char *fname) {

  struct stat stbuf;

  stat(fname, &stbuf);

  return ((long) stbuf.st_size); 

}



void senddata(int thesock, char *tpbuf) {
  write(thesock,tpbuf,strlen(tpbuf));
}



#ifdef SENDLASTMODIFIED

void sendlastmodified(int i, char *fbuf) {

  struct stat stbuf;
  char tpbuf[50];

  stat(fbuf, &stbuf);

  snprintf(tpbuf, sizeof(tpbuf), "Last-Modified: %s", 
                               ctime(&(stbuf.st_mtime)));

  senddata(infd[i], tpbuf);

}

#endif



#ifdef SENDMIMETYPE
void sendcontenttype(int i, char *cbuf) {
    char tpbuf[100];

    #ifdef CHARSET
    (void) snprintf( tpbuf, sizeof(tpbuf), get_mime_type( cbuf ), CHARSET );
    #endif
    #ifndef CHARSET
    (void) snprintf( tpbuf, sizeof(tpbuf), get_mime_type( cbuf ));
    #endif
    senddata(infd[i],"Content-Type: ");
    senddata(infd[i],tpbuf);
    senddata(infd[i],"\n");
}
#endif



/*Code from mini_httpd - small HTTP server
**
** Copyright C 1999,2000 by Jef Poskanzer <jef@acme.com>.
*/

/* mini_httpd code adapted for Anti-Web by zas@norz.org */
/* A couple TINY changes by Fractal */

#ifdef SENDMIMETYPE

static char*
get_mime_type( char* name )
{
    static struct {
        char* ext;
        char* type;
    }
    table[] = {
#include "mime_types.h"
              };
    int i;

    for ( i = 0; i < sizeof(table) / sizeof(*table); ++i ) {
        int el = strlen( table[i].ext );
        if ( strcasecmp( &(name[strlen(name) - el]), table[i].ext ) == 0 )
            return table[i].type;
    }
    /* FIXME: Maybe make this line return just a pointer. */
    #ifdef CHARSET
    return "text/plain; charset=%s";
    #endif
    return "text/plain";
}

#endif

/* End of mini_httpd code */





void stripcrlf(char *buf)
{
        register char *p=buf;
        while (p && *p) {
                        if (*p==CR || *p==LF) *p='\0';
                        p++;
        }
}



void serverinit() {

int vrai;

    if ((bindfd = socket(AF_INET, SOCK_STREAM, 0)) == -1) {
        fprintf(stderr,"AWHTTPD: Unable to create socket!\n");
        logthis(1,"Unable to create socket!");
        exit(0);
    }

/*
 On Linux, we need to enable SO_REUSEADDR option in order to re-bind immediately
 if the server dies for whatever reason [socket(7)]

 This excellent bugfix added by Fabrice Marie
*/
  if (setsockopt(bindfd, SOL_SOCKET, SO_REUSEADDR, &vrai, sizeof(vrai)) == -1) {
  logthis(3,"Unable to set the SO_REUSEADDR addr socket option! error follows: ");
  logthis(3, strerror(errno));
}
    
    my_addr.sin_family = AF_INET;         /* host byte order */
    my_addr.sin_port = htons(cnfport);    /* short, network byte order */

#ifdef BIND_ADDR   /* BIND_ADDR code from zas@norz.org */
    if (inet_aton(BIND_ADDR,&my_addr.sin_addr)==0)
#endif
    my_addr.sin_addr.s_addr = INADDR_ANY; /* automatically fill with my IP */

    memset(&(my_addr.sin_zero), 0, 8);        /* zero the rest of the struct */

    if (bind(bindfd, (struct sockaddr *)&my_addr, sizeof(struct sockaddr)) == -1) {
        fprintf(stderr,"AWHTTPD: Unable to bind!\n");
        logthis(1,"Unable to bind()! This port is probably in use!");
        exit(0);
    }

    if (listen(bindfd, BACKLOG) == -1) {
        fprintf(stderr,"AWHTTPD: Unable to listen!\n");
        logthis(1,"Unable to listen()!");
        exit(0);
    }
}
