/* Anti Web HTTPD */
/* HardCore Software */
/*
This software us Copyright (C) 2001 By HardCore Software.
The software is distributed under the terms of the GNU General Public
License. See the file 'LICENSE' for more details.
*/

/*
This cool little function tells you any files in your AW tree that are
unreadable by the UID that AW is running under. This function is a recursive
function. It will recall itself. Neat, eh?
*/

#ifdef PERMCHECK

void permcheck(char *pathtocheck) {

DIR *tpdir;
struct dirent *dp;
char thepath[MAXROOTDIRSIZE+100];

tpdir=opendir(pathtocheck);

if (tpdir==NULL) {
  printf("WARNING: UID (%d) is unable to read %s\n", getuid(), pathtocheck);
  return;
}

while ((dp=readdir(tpdir))) {

  #ifdef HIDEFILESSTARTINGWITHADOT
    if (strncmp(dp->d_name, ".", 1)==0) continue;
  #endif
  #ifdef HIDDENPREFIX
    if (strncmp(dp->d_name, HIDDENPREFIX, strlen(HIDDENPREFIX))==0) continue;
  #endif
  if (strcmp(dp->d_name, "..")==0) continue;
  if (strcmp(dp->d_name, ".")==0) continue;

  snprintf(thepath, sizeof(thepath), "%s/%s", pathtocheck, dp->d_name);

  if (isadir(thepath)) {
    permcheck(thepath);
    continue;
  }

  /* Note: We can use doesfileexist() for this because doesfileexist()
     actually checks if a file is READABLE... */
  if (!doesfileexist(thepath))
    printf("WARNING: UID (%d) is unable to read %s\n", getuid(), thepath);
     
}

return;

}

#endif
